import { Type } from "./type.js";
export const createMatchParser = (scope) => {
    const matchParser = (isRestricted) => {
        const handledCases = [];
        let defaultCase = null;
        const parser = {
            when: (when, then) => {
                handledCases.push({ when: new Type(when, scope), then });
                return parser;
            },
            finalize: () => {
                // TODO: exhaustiveness checking
                // const branches = handledCases.flatMap(({ when, then }) => {
                // 	if (when.root.kind === "union") {
                // 		return when.root.branches.map((branch) => ({
                // 			in: branch,
                // 			morph: then
                // 		}))
                // 	}
                // 	if (when.root.kind === "morph") {
                // 		return [{ in: when, morph: [when.root.morph, then] }]
                // 	}
                // 	return [{ in: when.root, morph: then }]
                // })
                // if (defaultCase) {
                // 	branches.push({ in: new Type("unknown", scope), morph: defaultCase })
                // }
                // const matchers = schema.union({
                // 	branches,
                // 	ordered: true
                // })
                // return (data: unknown) => {
                // 	const result = matchers.apply(data)
                // 	if (result.errors) {
                // 		throw result.errors
                // 	}
                // 	return result.out
                // }
            },
            orThrow: () => {
                // implicitly finalize, we don't need to do anything else because we throw either way
                return parser.finalize();
            },
            default: (x) => {
                if (x instanceof Function) {
                    defaultCase = x;
                }
                else {
                    defaultCase = () => x;
                }
                return parser.finalize();
            }
        };
        return parser;
    };
    return Object.assign(() => matchParser(false), {
        only: () => matchParser(true)
    });
};
//# sourceMappingURL=match.js.map