import { type nominal } from "@arktype/util";
import { writeUnexpectedCharacterMessage } from "./string/shift/operator/operator.js";
import { Scanner } from "./string/shift/scanner.js";
export type GenericDeclaration<name extends string = string, params extends string = string> = `${name}<${params}>`;
export type GenericParamsParseError<message extends string = string> = [
    nominal<message, "InvalidGenericParameters">
];
export declare const parseGenericParams: (def: string) => string[];
export type parseGenericParams<def extends string> = parseParamsRecurse<def, "", [
]> extends infer result extends string[] ? "" extends result[number] ? GenericParamsParseError<emptyGenericParameterMessage> : result : never;
export declare const emptyGenericParameterMessage = "An empty string is not a valid generic parameter name";
export type emptyGenericParameterMessage = typeof emptyGenericParameterMessage;
type parseParamsRecurse<unscanned extends string, param extends string, result extends string[]> = unscanned extends `${infer lookahead}${infer nextUnscanned}` ? lookahead extends "," ? parseParamsRecurse<nextUnscanned, "", [...result, param]> : lookahead extends Scanner.WhiteSpaceToken ? param extends "" ? parseParamsRecurse<Scanner.skipWhitespace<nextUnscanned>, "", result> : Scanner.skipWhitespace<nextUnscanned> extends `${infer nextNonWhitespace}${infer rest}` ? nextNonWhitespace extends "," ? parseParamsRecurse<rest, "", [...result, param]> : GenericParamsParseError<writeUnexpectedCharacterMessage<nextNonWhitespace, ",">> : [
    ...result,
    param
] : parseParamsRecurse<nextUnscanned, `${param}${lookahead}`, result> : param extends "" ? result : [...result, param];
export {};
//# sourceMappingURL=generic.d.ts.map