import { throwParseError } from "@arktype/util";
import { writeUnexpectedCharacterMessage } from "./string/shift/operator/operator.js";
import { Scanner } from "./string/shift/scanner.js";
export const parseGenericParams = (def) => parseGenericParamsRecurse(new Scanner(def));
export const emptyGenericParameterMessage = `An empty string is not a valid generic parameter name`;
const parseGenericParamsRecurse = (scanner) => {
    const param = scanner.shiftUntilNextTerminator();
    if (param === "") {
        throwParseError(emptyGenericParameterMessage);
    }
    scanner.shiftUntilNonWhitespace();
    const nextNonWhitespace = scanner.shift();
    return nextNonWhitespace === ""
        ? [param]
        : nextNonWhitespace === ","
            ? [param, ...parseGenericParamsRecurse(scanner)]
            : throwParseError(writeUnexpectedCharacterMessage(nextNonWhitespace, ","));
};
//# sourceMappingURL=generic.js.map