import type { TypeNode } from "@arktype/schema";
import { type requireKeys } from "@arktype/util";
import type { ParseContext } from "../../../scope.js";
import { Scanner } from "../shift/scanner.js";
import { type Comparator, type LimitLiteral, type OpenLeftBound, type StringifiablePrefixOperator } from "./shared.js";
type BranchState = {
    prefixes: StringifiablePrefixOperator[];
    leftBound?: OpenLeftBound;
    "&"?: TypeNode;
    "|"?: TypeNode;
};
export type DynamicStateWithRoot = requireKeys<DynamicState, "root">;
export declare class DynamicState {
    readonly ctx: ParseContext;
    readonly scanner: Scanner;
    root: TypeNode | undefined;
    branches: BranchState;
    finalizer: Scanner.FinalizingLookahead | undefined;
    groups: BranchState[];
    constructor(def: string, ctx: ParseContext);
    error(message: string): never;
    hasRoot(): this is DynamicStateWithRoot;
    unsetRoot(): this["root"];
    constrainRoot(...args: Parameters<TypeNode["constrain"]>): void;
    setRoot(root: TypeNode): void;
    finalize(finalizer: Scanner.FinalizingLookahead): undefined;
    reduceLeftBound(limit: LimitLiteral, comparator: Comparator): undefined;
    finalizeBranches(): void;
    finalizeGroup(): undefined;
    addPrefix(prefix: StringifiablePrefixOperator): void;
    applyPrefixes(): void;
    pushRootToBranch(token: "|" | "&"): void;
    parseUntilFinalizer(): DynamicStateWithRoot;
    parseOperator(this: DynamicStateWithRoot): void;
    parseOperand(): void;
    private assertRangeUnset;
    reduceGroupOpen(): void;
    previousOperator(): ">" | ">=" | "|" | "&" | "keyof" | undefined;
    shiftedByOne(): this;
}
export {};
//# sourceMappingURL=dynamic.d.ts.map