import type { DateLiteral } from "@arktype/schema";
export type StringifiablePrefixOperator = "keyof";
export declare const minComparators: {
    readonly ">": true;
    readonly ">=": true;
};
export type MinComparator = keyof typeof minComparators;
export declare const maxComparators: {
    readonly "<": true;
    readonly "<=": true;
};
export type MaxComparator = keyof typeof maxComparators;
export declare const comparators: {
    "==": boolean;
    "<": true;
    "<=": true;
    ">": true;
    ">=": true;
};
export type Comparator = keyof typeof comparators;
export declare const invertedComparators: {
    readonly "<": ">";
    readonly ">": "<";
    readonly "<=": ">=";
    readonly ">=": "<=";
    readonly "==": "==";
};
export type InvertedComparators = typeof invertedComparators;
export type LimitLiteral = number | DateLiteral;
export type OpenLeftBound = {
    limit: LimitLiteral;
    comparator: MinComparator;
};
export declare const writeUnmatchedGroupCloseMessage: <unscanned extends string>(unscanned: unscanned) => `Unmatched )${unscanned extends "" ? "" : ` before ${unscanned}`}`;
export type writeUnmatchedGroupCloseMessage<unscanned extends string> = `Unmatched )${unscanned extends "" ? "" : ` before ${unscanned}`}`;
export declare const writeUnclosedGroupMessage: <missingChar extends string>(missingChar: missingChar) => `Missing ${missingChar}`;
export type writeUnclosedGroupMessage<missingChar extends string> = `Missing ${missingChar}`;
export declare const writeOpenRangeMessage: <min extends LimitLiteral, comparator extends ">" | ">=">(min: min, comparator: comparator) => `Left bounds are only valid when paired with right bounds (try ...${comparator}${min})`;
export type writeOpenRangeMessage<min extends LimitLiteral, comparator extends MinComparator> = `Left bounds are only valid when paired with right bounds (try ...${comparator}${min})`;
export type writeUnpairableComparatorMessage<comparator extends Comparator> = `Left-bounded expressions must specify their limits using < or <= (was ${comparator})`;
export declare const writeUnpairableComparatorMessage: <comparator extends "==" | "<" | "<=" | ">" | ">=">(comparator: comparator) => `Left-bounded expressions must specify their limits using < or <= (was ${comparator})`;
export declare const writeMultipleLeftBoundsMessage: <openLimit extends LimitLiteral, openComparator extends ">" | ">=", limit extends LimitLiteral, comparator extends ">" | ">=">(openLimit: openLimit, openComparator: openComparator, limit: limit, comparator: comparator) => `An expression may have at most one left bound (parsed ${openLimit}${{
    readonly "<": ">";
    readonly ">": "<";
    readonly "<=": ">=";
    readonly ">=": "<=";
    readonly "==": "==";
}[openComparator]}, ${limit}${{
    readonly "<": ">";
    readonly ">": "<";
    readonly "<=": ">=";
    readonly ">=": "<=";
    readonly "==": "==";
}[comparator]})`;
export type writeMultipleLeftBoundsMessage<openLimit extends LimitLiteral, openComparator extends MinComparator, limit extends LimitLiteral, comparator extends MinComparator> = `An expression may have at most one left bound (parsed ${openLimit}${InvertedComparators[openComparator]}, ${limit}${InvertedComparators[comparator]})`;
//# sourceMappingURL=shared.d.ts.map