import { writeUnclosedGroupMessage } from "../../reduce/shared.js";
export const parseGenericArgs = (name, params, s) => parseGenericArgsRecurse(name, params, s, [], []);
const parseGenericArgsRecurse = (name, params, s, argDefs, argNodes) => {
    const argState = s.parseUntilFinalizer();
    // remove the finalizing token from the argDef
    argDefs.push(argState.scanner.scanned.slice(0, -1));
    argNodes.push(argState.root);
    if (argState.finalizer === ">") {
        if (argNodes.length === params.length) {
            return {
                result: argNodes,
                unscanned: argState.scanner.unscanned
            };
        }
        else {
            return argState.error(writeInvalidGenericArgsMessage(name, params, argDefs));
        }
    }
    else if (argState.finalizer === ",") {
        return parseGenericArgsRecurse(name, params, s, argDefs, argNodes);
    }
    return argState.error(writeUnclosedGroupMessage(">"));
};
export const writeInvalidGenericArgsMessage = (name, params, argDefs) => `${name}<${params.join(", ")}> requires exactly ${params.length} args (got ${argDefs.length}${argDefs.length === 0 ? "" : ": " + argDefs.join(", ")})`;
//# sourceMappingURL=genericArgs.js.map